export declare const VERSION = 0;
export declare enum TYPES {
    Data = 0,
    WindowUpdate = 1,
    Ping = 2,
    GoAway = 3
}
export declare enum FLAGS {
    SYN = 1,
    ACK = 2,
    FIN = 4,
    RST = 8
}
export declare enum STREAM_STATES {
    Init = 0,
    SYNSent = 1,
    SYNReceived = 2,
    Established = 3,
    LocalClose = 4,
    RemoteClose = 5,
    Closed = 6,
    Reset = 7
}
export declare const initialStreamWindow: number;
export declare enum GO_AWAY_ERRORS {
    goAwayNormal = 0,
    goAwayProtoErr = 1,
    goAwayInternalErr = 2
}
export declare enum ERRORS {
    errInvalidVersion = "invalid protocol version",
    errInvalidMsgType = "invalid msg type",
    errSessionShutdown = "session shutdown",
    errStreamsExhausted = "streams exhausted",
    errDuplicateStream = "duplicate stream initiated",
    errRecvWindowExceeded = "recv window exceeded",
    errTimeout = "i/o deadline reached",
    errStreamClosed = "stream closed",
    errUnexpectedFlag = "unexpected flag",
    errRemoteGoAway = "remote end is not accepting connections",
    errConnectionReset = "connection reset",
    errConnectionWriteTimeout = "connection write timeout",
    errKeepAliveTimeout = "keepalive timeout"
}
